import java.awt.*;
import javax.swing.*;
import WebFlow.submitJob2.*;
import java.io.*;
import java.util.*;

public class crpcSend implements Runnable {

private String file_name;
private boolean debug;
private JTextArea resultText;
private JScrollPane sp;
private JViewport vp;
private Point p;
private Dimension d;
private int x,y;

    public crpcSend(String file_name, JTextArea resultText, JScrollPane sp,
		    boolean debug) {
	this.file_name = file_name;
	this.resultText = resultText;
	this.sp = sp;
	this.debug = debug;

	vp = sp.getViewport();
	p = vp.getViewPosition();
	d = vp.getExtentSize();
	x=p.x;
    }

    public void run(){
	System.out.println("crpcSend Started............") ;
	System.out.println("debug is " + debug) ;
	
	String src = "/home/pse/CRPC/beowulf/";
	String dest = "/home/webrun/";
	String remotehost = "oscbw.osc.edu";
	String user = "pse";
	
	if (file_name.equals("vel")) {

	    int vel_size = 25;
	    int conc_size = 31; 
	    String[] vel_flag;
	    vel_flag = new String[vel_size];
	    boolean vel_flag_check = false;
	    int vel_count=0, pres_count=0, conc_count = 0;
	 
	    for(int i=0; i < vel_size; i++) 
		{
		    vel_flag[i] = "N";
		    if(debug) System.out.println("vel_flag = "+vel_flag[i]);
		}

	    while(!vel_flag_check) {
	      
		do {
		    if (debug) System.out.println("velTime file Not exist...");
		    Connection.submit.importFile(src+"velTime", dest, remotehost, user);
		} while (!Connection.remote.exists(dest+"velTime"));  

		if(debug) System.out.println("velTime reading.....\n");

		vel_count = 0;

		try {

		    Connection.remote.open(dest+"velTime", "r");
		    byte[] vel_read = Connection.remote.getBlock();
		    String vel_check = new String(vel_read);

		    StringTokenizer st = new StringTokenizer(vel_check);
		    while (st.hasMoreTokens()) {
			st.nextToken();
			st.nextToken();
			if( vel_flag[vel_count] == "N" ) vel_flag[vel_count] = "Y";
			vel_count = vel_count + 1; 
		    }
        
		    if (debug) System.out.println("Reading veltime: "+vel_check);
		    if(debug) System.out.println("vel_count= "+vel_count);
		    for(int i=0; i < vel_size; i++) 
			{
			    if(debug) System.out.println("vel_flag readable = "+vel_flag[i]);
			}
		    Connection.remote.close();

		} catch(WebFlow.RemoteFile.RemoteFilePackage.FileException ex)
		    {
			if (debug) { System.out.println("Can't read from `" +
						    ex.getMessage() + "'");
			System.exit(1); }
		    } catch (WebFlow.RemoteFile.RemoteFilePackage.EOFFileException ex1) {
			if (debug) { System.out.println("Can't read from `" +
			              ex1.getMessage() + "'");
		        System.exit(1); }
		    }
	  
		String vel_file;
		for (int i = 0; i < 10; i++) {
		 
		    vel_file = "vel.00" + i + ".plt" ;

		    if (vel_flag[i] == "Y") {
			do {
			    Connection.submit.importFile(src+vel_file, dest, remotehost, user);
			}while (!Connection.remote.exists(dest+vel_file));
			vel_flag[i] = "R";
		    }
		}  //for i=0

		for (int i = 10; i < 25; i++) {
		    vel_file = "vel.0" + i + ".plt" ;
		    
		    if (vel_flag[i] == "Y") {
			do {
			    Connection.submit.importFile(src+vel_file, dest, remotehost, user);
			} while (!Connection.remote.exists(dest+vel_file));
			vel_flag[i] = "R";
		    }
		}
		
		if (vel_size == vel_count) {
		    int vel_index = 0;
		    
		    while( vel_flag[vel_index] == "R" ) vel_index = vel_index + 1;
		    if ( vel_count == vel_index ) vel_flag_check = true;
		}
	    } //while outer
	} //if (vel parameter check
    } //void run


    public void submitJobcrpc(String command) {
	Connection.submit.submitLocally(command);

	if(debug) System.out.println("run locally completed");
	String OLine="";
	resultText.setText(OLine);
	int curLine=0; 
	if(debug) System.out.println("start reading...");
	while(!OLine.equals("theEnd")) {
	    OLine=Connection.submit.getOLine(curLine);
	    if(OLine.equals("wait")) {
		if(debug) System.out.println("waiting...");
		waitFor(10);
	    }
	    else {
		if(debug) System.out.println(curLine+" "+OLine);
		resultText.append(OLine+"\n");
		
		Connection.submit.setLineRead(curLine);
		curLine++;
		if(curLine==20) curLine=0;
	    } 
	}
    }

  public synchronized void waitFor(long howLong){
     try {
        wait(howLong);
     } catch (Exception e) { System.out.println(e);}
   }

}






















